# How to Import and Export Excel XLSX Using JavaScript

Learn how to import and export Excel XLSX files using JavaScript.

## Content

This tutorial shows how to import and export Excel XLSX files in a JavaScript application using **[SpreadJS](https://developer.mescius.com/spreadjs "https://developer.mescius.com/spreadjs")**[, a JavaScript spreadsheet component](https://developer.mescius.com/spreadjs "https://developer.mescius.com/spreadjs"). You’ll learn how to set up a JavaScript project, add a spreadsheet component, and enable Excel import/export.

**Try Out an Import and Export Sample**

<iframe src="https://stackblitz.com/edit/spreadjs-import-export-excel?embed=1&amp;file=src%2Fmain.js" style="height: 500px;width: 100%;"></iframe>

You can also [download the full sample](https://drive.mescius.io/download?file=ExternalShare/SpreadJS/Samples/export-excel-js.zip "https://drive.mescius.io/download?file=ExternalShare/SpreadJS/Samples/export-excel-js.zip") to run locally, or check out our [online interactive IO demo](https://developer.mescius.com/spreadjs/demos/features/spreadjs-file-format/overview/purejs "https://developer.mescius.com/spreadjs/demos/features/spreadjs-file-format/overview/purejs").

***

## Set Up the JavaScript Spreadsheet Project

To start, we have a simple JavaScript application consisting of an HTML file (index.html) and a JavaScript module (main.js).
Install the required npm packages: [Spread-Sheets library](https://www.npmjs.com/package/@mescius/spread-sheets "https://www.npmjs.com/package/@mescius/spread-sheets"){:target="_blank"}, [Spread-Sheets-IO](https://www.npmjs.com/package/@mescius/spread-sheets-io "https://www.npmjs.com/package/@mescius/spread-sheets-io"){:target="_blank"}, and [FileSaver](https://www.npmjs.com/package/file-saver "https://www.npmjs.com/package/file-saver"){:target="_blank"}.

```auto
npm install @mescius/spread-sheets 
npm install @mescius/spread-sheets-io 
npm install file-saver 
```

Import the JavaScript (and CSS) modules into our src/main.js file:

```auto
import '@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css'
import * as GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-io';
import 'file-saver';
```

Add a `<div>` tag in our index.html file to host the JavaScript spreadsheet.

```auto
<div id="hostElement"></div>
```

In src/main.js, initialize the [SpreadJS Workbook component ](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#constructor)by passing in the ID of the \<div> host element:

```auto
let workbook = new GC.Spread.Sheets.Workbook('hostElement');
```

With the steps so far, the JavaScript app renders a basic spreadsheet.

***

## Add Excel Import Code to a JavaScript App

Add an input element and a button to allow users to select their Excel (XLSX) file. Set `accept=".xlsx"` so only Excel (.xlsx) files can be selected.

```auto
<input type="file" id="selectedFile" accept=".xlsx" />
<button class="settingButton" id="btnImport">Import</button>
```

Add a function to import a selected file using the SpreadJS **[import](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#import)**[ ](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#import)method. This function will be called by the click event handler of the *Import* button:

```auto
document.getElementById('btnImport').addEventListener('click', handleImport);
function handleImport(e) {
    let file = document.querySelector('#selectedFile').files[0];
    if (!file) {
        return;
    }
    workbook.import(file);
}
```

An Excel (.xlsx) file can now be imported and viewed in the JavaScript spreadsheet component, like so:
![image](https://cdn.mescius.io/document-site-files/images/b2223940-43c2-44cf-8eda-f5ab9acd84f0/image.7dc8a0.png)

## Add Excel Export Code to a JavaScript App

Add a function to export the spreadsheet to an Excel file using the SpreadJS **[export](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#export)**[ ](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#export)method. This function will be called by the click event handler of the *Export* button:

```auto
document.getElementById('btnExport').addEventListener('click', handleExport);
function handleExport(e) {
    let fileName = document.getElementById('exportFileName').value;
    if (fileName.substr(-5, 5) !== '.xlsx') {
        fileName += '.xlsx';
    }
    workbook.export(function (blob) {
        // save blob to a file
        saveAs(blob, fileName);
    }, function (e) {
        console.log(e);
    }, {
        fileType: GC.Spread.Sheets.FileType.excel
    });
}
```

That code gets the export file name from an **exportFileName** input element. Define an input field to let users enter a file name:

```auto
<input type="text" id="exportFileName" placeholder="Export file name" value="export.xlsx" />
```

Add an Export file button:

```auto
<button id="btnExport">Export File</button> 
```

Users can now edit the spreadsheet within the JavaScript app and export it with the Export File button. The exported file opens in Excel with all changes preserved.
![image](https://cdn.mescius.io/document-site-files/images/b2223940-43c2-44cf-8eda-f5ab9acd84f0/image.7d166a.png)
This is just one example of how you can use SpreadJS JavaScript spreadsheets to add data to your Excel files and then export them back to Excel with simple JavaScript code.

### Include Extra Features

If you want to import and export Excel files with Charts, Shapes, and PivotTables, make sure to include those optional add-on modules for SpreadJS ([@mescius/spread-sheets-charts](https://www.npmjs.com/package/@mescius/spread-sheets-charts "https://www.npmjs.com/package/@mescius/spread-sheets-charts"){:target="_blank"}, [@mescius/spread-sheets-shapes](https://www.npmjs.com/package/@mescius/spread-sheets-shapes "https://www.npmjs.com/package/@mescius/spread-sheets-shapes"){:target="_blank"}, and [@mescius/spread-sheets-pivot-addon](https://www.npmjs.com/package/@mescius/spread-sheets-pivot-addon "https://www.npmjs.com/package/@mescius/spread-sheets-pivot-addon"){:target="_blank"}).

***

### Import and Export Excel FAQs

**Do I need to have Excel installed for this import or export in JavaScript to work?**
No! SpreadJS is a stand-alone JavaScript component that can import and export Excel files without depending on Excel at all.
**Can my end users changes be included in the export?**
Yes! SpreadJS allows users to modify spreadsheets in an Excel-like experience. Those changes will be included when the spreadsheet is exported.
**What types of files can be imported or exported?**
SpreadJS supports import and export of .xlsx, .xlsm, .xltm file types. It can even import .csv files and has a custom SpreadJS (.sjs)file format for optimized performance and app development.
**Do you support Excel files with macros?**
The macros will not run, but Excel files with macros can be imported and exported without losing the macros. The macros simply will be ignored when the spreadsheet runs in SpreadJS. Note: most macro use cases can be replicated in custom JavaScript code using SpreadJS

***

### Next Steps

* [Download Local Tutorial JavaScript Sample App](https://drive.mescius.io/download?file=ExternalShare/SpreadJS/Samples/export-excel-js.zip "https://drive.mescius.io/download?file=ExternalShare/SpreadJS/Samples/export-excel-js.zip")
* [Check Out the Online Interactive JavaScript I/O Demo](https://developer.mescius.com/spreadjs/demos/features/spreadjs-file-format/overview/purejs "https://developer.mescius.com/spreadjs/demos/features/spreadjs-file-format/overview/purejs")
* [Watch Our How-To Video](https://www.youtube.com/watch?v=rGIFbNKhnxQ "#Watch-Our-How-To-Video"){:target="_blank"}

# How to Import and Export Excel XLSX Using Vue

Learn how to import and export Excel XLSX files using Vue. See more from SpreadJS today.

## Content

This tutorial shows how to import and export Excel XLSX files in a Vue application using [SpreadJS, a Vue spreadsheet component](https://developer.mescius.com/spreadjs/vue-spreadsheet-components "https://developer.mescius.com/spreadjs/vue-spreadsheet-components"). You’ll learn how to set up a Vue project, add a spreadsheet component, and enable Excel import/export.
**Try Out an Import and Export Sample**

<iframe src="https://stackblitz.com/edit/spreadjs-import-export-excel-vue?embed=1&amp;file=src%2FApp.vue" style="height: 500px; width: 100%;"></iframe>

You can also [download the full sample](https://drive.mescius.io/download?file=ExternalShare/SpreadJS/Samples/vue-io-xlsx.zip "https://drive.mescius.io/download?file=ExternalShare/SpreadJS/Samples/vue-io-xlsx.zip") to run locally, or check out our [online interactive IO demo](https://developer.mescius.com/spreadjs/demos/features/spreadjs-file-format/overview/vue3 "https://developer.mescius.com/spreadjs/demos/features/spreadjs-file-format/overview/vue3").

***

## Set Up the Vue Spreadsheet Project

Run the following NPM command to create a new Vue app:

```auto
npm create vue@latest 
```

![image](https://cdn.mescius.io/document-site-files/images/b2223940-43c2-44cf-8eda-f5ab9acd84f0/image.0ddfa6.png)
Install the required npm packages:

```auto
npm install @mescius/spread-sheets 
npm install @mescius/spread-sheets-io 
npm install @mescius/spread-sheets-vue
npm install file-saver 
```

* [@mescius/spread-sheets](https://www.npmjs.com/package/@mescius/spread-sheets "https://www.npmjs.com/package/@mescius/spread-sheets"){:target="_blank"} – base SpreadJS library
* [@mescius/spread-sheets-io](https://www.npmjs.com/package/@mescius/spread-sheets-io "https://www.npmjs.com/package/@mescius/spread-sheets-io"){:target="_blank"} – Excel import/export
* [@mescius/spread-sheets-vue](https://www.npmjs.com/package/@mescius/spread-sheets-vue "https://www.npmjs.com/package/@mescius/spread-sheets-vue"){:target="_blank"} – Vue spreadsheet components
* [file-saver](https://www.npmjs.com/package/file-saver "https://www.npmjs.com/package/file-saver"){:target="_blank"} – lets users save files locally

Import and register the Vue spreadsheet components in src/main.js:

```auto
import './assets/main.css'

import { createApp } from 'vue'
import App from './App.vue'
import {
  GcSpreadSheets,
  GcWorksheet,
  GcColumn,
} from "@mescius/spread-sheets-vue";

let app = createApp(App);
app.component("gc-spread-sheets", GcSpreadSheets);
app.component("gc-worksheet", GcWorksheet);
app.component("gc-column", GcColumn);
app.mount("#app");
```

***

## Add Spreadsheet to App Vue Component

Now, its time to build our spreadsheet into our App.vue component (or component of your choice).
In src/App.vue, import the JavaScript (and CSS) modules in the`<script setup>`:

```auto
import '@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css'
import * as GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-io';
import 'file-saver';
```

In the \<template> markup, declare the [SpreadJS Workbook component](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#constructor):

```auto
<gc-spread-sheets class="spread-host" @workbookInitialized="initSpread">
</gc-spread-sheets>
```

In `<script setup>`, declare the needed variables and the `initSpread` handler to populate the `workbook` variable when the SpreadJS instance is initialized.

```auto
let workbook = null;
let file = null;
let exportFileName = 'export.xlsx';

function initSpread(spread) {
  workbook = spread;
}
```

With the steps so far, the Vue app renders a basic spreadsheet.

***

## Add Excel Import Code to a Vue App

Add an input element and a button to allow users to select their Excel (XLSX) file. Set `accept=".xlsx"` so only Excel (.xlsx) files can be selected.

```auto
<input type="file" id="selectedFile" accept=".xlsx" @change="handleFileChange" />
<button id="btnImport" @click="handleImport">Import</button>
```

The input has a change event handler that updates the file variable to the most recently selected file. The file change handler is quite simple:

```auto
function handleFileChange(e) {
  file = e.target.files[0];
}
```

The button has a click handler that triggers the file import.
To make that work, add a function to import a file using spreads **[import](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#import)**[ ](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#import)method. These handlers are also added to the`<script setup>` in src/App.vue.

```auto
function handleImport(e) {
  //let file = document.querySelector('#selectedFile').files[0];
  if (!file) {
    return;
  }
  workbook.import(file);
}
```

An Excel (.xlsx) file can now be imported and viewed in the Vue spreadsheet component like so:
![image](https://cdn.mescius.io/document-site-files/images/b2223940-43c2-44cf-8eda-f5ab9acd84f0/image.c4d0f3.png)

***

## Add Excel Export Code to a Vue App

Add a button to export the file by invoking the Spreadsheet’s **[export](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#export)**[ ](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#export)method in its click event handler:

```auto
function handleExport(e) {
  if (exportFileName.substr(-5, 5) !== '.xlsx') {
    exportFileName += '.xlsx';
  }

  workbook.export(
    function (blob) {
      // save blob to a file
      saveAs(blob, exportFileName);
    },
    function (e) {
      console.log(e);
    },
    {
      fileType: GC.Spread.Sheets.FileType.excel,
    }
  );
}
```

The export file name is bound to the `exportFileName `variable using `v-model`. Define an input field to let users enter a file name:

```auto
<input type="text" id="exportFileName" v-model="exportFileName" />
```

Add an Export File button that calls the `handleExport` function on click.

```auto
<button id="btnExport" @click="handleExport">Export File</button> 
```

Users can now edit the spreadsheet within the Vue app and export it with the Export File button. The exported file opens in Excel with all changes preserved.
![image](https://cdn.mescius.io/document-site-files/images/b2223940-43c2-44cf-8eda-f5ab9acd84f0/image.9dcff3.png)
This is just one example of how you can use SpreadJS Vue spreadsheets to add data to your Excel files and then export them back to Excel with simple Vue code.

***

### **Include Extra Features**

If you want to import and export Excel files with Charts, Shapes and PivotTables, make sure to include those optional add-on modules for SpreadJS ([@mescius/spread-sheets-charts](https://www.npmjs.com/package/@mescius/spread-sheets-charts "https://www.npmjs.com/package/@mescius/spread-sheets-charts"){:target="_blank"}, [@mescius/spread-sheets-shapes](https://www.npmjs.com/package/@mescius/spread-sheets-shapes "https://www.npmjs.com/package/@mescius/spread-sheets-shapes"){:target="_blank"} and [@mescius/spread-sheets-pivot-addon](https://www.npmjs.com/package/@mescius/spread-sheets-pivot-addon "https://www.npmjs.com/package/@mescius/spread-sheets-pivot-addon"){:target="_blank"}).

***

### **Import and Export Excel FAQs**

**Do I need to have Excel installed for this import or export in JavaScript to work?**
No! SpreadJS is a stand-alone JavaScript component that can import and export Excel files without depending on Excel at all.
**Can my end users changes be included in the export?**
Yes! SpreadJS allows users to modify spreadsheets in an Excel-like experience. Those changes will be included when the spreadsheet is exported.
**What types of files can be imported or exported?**
SpreadJS supports import and export of .xlsx, .xlsm, .xltm file types. It can even import .csv files and has a custom SpreadJS (.sjs)file format for optimized performance and app development.
**Do you support Excel files with macros?**
The macros will not run, but Excel files with macros can be imported and exported without losing the macros. The macros simply will be ignored when the spreadsheet runs in SpreadJS. Note: most macro use cases can be replicated in custom JavaScript code using SpreadJS

***

### **Next Steps**

* [Download Local Tutorial Vue Sample App](https://drive.mescius.io/download?file=ExternalShare/SpreadJS/Samples/vue-io-xlsx.zip "https://drive.mescius.io/download?file=ExternalShare/SpreadJS/Samples/vue-io-xlsx.zip")
* [Check Out the Online Interactive Vue I/O Demo](https://developer.mescius.com/spreadjs/demos/features/spreadjs-file-format/overview/vue3 "https://developer.mescius.com/spreadjs/demos/features/spreadjs-file-format/overview/vue3")
* [Watch Our How-to Video](https://www.youtube.com/watch?v=10ioYwTa5zE){:target="_blank"}

# How to Import and Export Excel XLSX Using Angular

Learn how to import and export Excel XLSX files using Angular.

## Content

This tutorial shows how to import and export Excel XLSX files in an Angular application using **[SpreadJS](https://developer.mescius.com/spreadjs "https://developer.mescius.com/spreadjs")**[, an ](https://developer.mescius.com/spreadjs "https://developer.mescius.com/spreadjs")[Angular spreadsheet component](https://developer.mescius.com/spreadjs/angular-spreadsheet-components "https://developer.mescius.com/spreadjs/angular-spreadsheet-components"). You’ll learn how to set up an Angular project, add a spreadsheet component, and enable Excel import/export.
**Try Out an Import and Export Sample**

<iframe src="https://stackblitz.com/edit/spreadjs-import-export-excel-angular?embed=1&amp;file=src%2Fapp%2Fapp.ts" style="height: 500px;width: 100%;">You can also [download the full sample](https://drive.mescius.io/download?file=ExternalShare/SpreadJS/Samples/spreadjs-angular-io.zip "https://drive.mescius.io/download?file=ExternalShare/SpreadJS/Samples/spreadjs-angular-io.zip") to run locally or check out our [online interactive IO demo](https://developer.mescius.com/spreadjs/demos/features/spreadjs-file-format/overview/angular "https://developer.mescius.com/spreadjs/demos/features/spreadjs-file-format/overview/angular").</iframe>

***

## Create an Angular Spreadsheet Application

Install the @angular/cli package.

```auto
npm i -g @angular/cli
```

Run the following NPM command to create a new Angular app:

```auto
ng new spreadjs-angular-io
cd spreadjs-angular-io
```

Install the required npm packages: [Spread-Sheets](https://www.npmjs.com/package/@mescius/spread-sheets "https://www.npmjs.com/package/@mescius/spread-sheets"){:target="_blank"}, [Spread-Sheets-Angular](https://www.npmjs.com/package/@mescius/spread-sheets-angular "https://www.npmjs.com/package/@mescius/spread-sheets-angular"){:target="_blank"}, [Spread-Sheets-IO](https://www.npmjs.com/package/@mescius/spread-sheets-io "https://www.npmjs.com/package/@mescius/spread-sheets-io"){:target="_blank"}, and [Spread-Sheet-Charts](https://www.npmjs.com/package/@mescius/spread-sheets-charts "https://www.npmjs.com/package/@mescius/spread-sheets-charts"){:target="_blank"}.

```auto
npm install @mescius/spread-sheets 
npm install @mescius/spread-sheets-angular
npm install @mescius/spread-sheets-io 
npm install @mescius/spread-sheets-charts
```

Import the JavaScript (and CSS) modules into our src/main.js file:

```auto
import '@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css'
import * as GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-io';
import 'file-saver';
```

Open the **app.ts** file and add the necessary imports for the SpreadJS module, as noted below.

```auto
import { Component } from '@angular/core';
import { SpreadSheetsModule } from "@mescius/spread-sheets-angular";
import * as GC from "@mescius/spread-sheets";
import '@mescius/spread-sheets-io';
import '@mescius/spread-sheets-charts';
@Component({
  selector: 'app-root',
  imports: [SpreadSheetsModule],
  template: `  
    Welcome to Angular!
  `,
  styles: [],
})
export class App {
  protected title = 'spreadjs-angular-io';
}
```

In the **app.ts** file delete the `template`'s placeholder contents (or in the app.html file if you are using a templateUrl). Then add SpreadJS’ Angular Template to the application, along with buttons for opening, exporting, and modifying the .xlsx file like so:

```auto
@Component({
  selector: 'app-root',
  imports: [SpreadSheetsModule],
  template: `
  <div class="container">
    <div class="spread-panel">
      <gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="workbookInit($event)">
      </gc-spread-sheets>
    </div>
    <div class="side-panel">
        <label for="selectedFile">Open Excel .xlsx File:</label>
        <input id="selectedFile" type="file" accept=".xlsx" (change)="selectedFileChange($event)" />
        <button (click)="open()" id="open">Import</button>
        <br/>
        <label>Add Data</label><br/>
        <button (click)="addCustomer()">Add Customer</button>
        <br/>
        <label>Export Excel file:</label><br/>
        <button (click)="save()">Export File</button>
    </div>
  </div>
  `,
  styles: [],
})
```

In the **app.ts** file, add the following code to the App class to add the Angular spreadsheet component to the application and **[initialize the workbook](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#constructor)**. We also have a few placeholder functions that we will fill out later.

```auto
export class App {
  protected title = 'spreadjs-angular-io';
   hostStyle = {
    width: '100%',
    height: '600px'
  };
  spread: GC.Spread.Sheets.Workbook | any = null;
  columnWidth = 100;
  constructor() {
  }
  // Initialize SpreadJS
  workbookInit($event: any) {
    this.spread = $event.spread;
  }
  // Get the selected Excel file
  selectedFileChange(e: any) {
  }
  // Imported the Excel file into SpreadJS
  open() {
  }
  // Modify data imported
  addCustomer() {
  }
  // Save the instance as an Excel File
  save() {
  }
```

Open the **styles.css** file and import the SpreadJS stylesheet (as shown below). This applies one of the [built-in themes](/spreadjs/docs/features/styletheme), changing the UI of the spreadsheet instance—[refer to our demo for more details](https://developer.mescius.com/spreadjs/demos/features/theme/spread-theme/angular "https://developer.mescius.com/spreadjs/demos/features/theme/spread-theme/angular"). We will also add some styles for the layout of the SpreadJS panel and side panel.

```auto
@import '@mescius/spread-sheets/styles/gc.spread.sheets.excel2016darkGray.css';
body {
    font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI Light', Roboto,
    Oxygen-Sans, Ubuntu, Cantarell, 'Helvetica Neue', sans-serif;
}
.container {
  display: flex;
  flex-direction: row;
  flex-wrap: nowrap;
  height: 100%;
}
.spread-panel {
  flex: 1 1 auto;
}
.side-panel {
  width: 200px;
  padding: 1rem;    
  background-color: #f2f2f2;
}
.side-panel input {
  width: 100%;
  min-width: 100px;
}
```

Save all the files, and run the Angular app:

```auto
npm start
```

With the steps so far, the Angular app renders a basic spreadsheet.
![image](https://cdn.mescius.io/document-site-files/images/b2223940-43c2-44cf-8eda-f5ab9acd84f0/image.b7f6da.png)

***

## Add Excel Import Code to an Angular App

SpreadJS has a workbook **[import](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#import)**[ ](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#import)method that imports the object state from Excel. Before we can invoke this method, we must get the user-selected .xlsx file. To do this, we will go to the **app.ts** file, and add `selectedFile` variable:

```auto
export class App {
  protected title = 'spreadjs-angular-io';
   hostStyle = {
    width: '100%',
    height: '600px'
  };
  spread: GC.Spread.Sheets.Workbook | any = null;
  columnWidth = 100;
   // Stores the user-selected file in the selectedFileChange function
  selectedFile: File | any = null;
  constructor() {
  }
...
```

In the `selectedFileChange()` function store the selected file object in the `selectedFile` variable :

```auto
// Get the selected Excel file
  selectedFileChange(e: any) {
      this.selectedFile = e.target.files[0];
}
```

Now, in the `open()` function, with the `selectedFile`, invoke the SpreadJS **[import](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#import)**[ ](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#import)method, be sure to specify the **[FileType](/spreadjs/api/enums/GC.Spread.Sheets.FileType)**[ ](/spreadjs/api/enums/GC.Spread.Sheets.FileType)as *excel*.

```auto
open() {
    let file = this.selectedFile;
        if (!file) {
            return;
        }
    // Specify the file type to ensure proper import
    const options: GC.Spread.Sheets.ImportOptions = {
      fileType: GC.Spread.Sheets.FileType.excel
    };
    if(this.spread){
      this.spread.import(file, () => {
        console.log('Import successful');
      }, (e: any) => {
        console.error('Error during import:', e);
      }, options);
    }
}
```

With these steps, you've successfully add Excel import functionality to the Angular spreadsheet application.
![Add Excel XLSX Import Functionality to an Angular Application](https://cdn.mescius.io/document-site-files/images/7719ad0a-f083-46d7-aff6-f63e2e187c15/excel-import-angular.885220.gif)

***

## Add Excel Export Code to an Angular App

With the **[export](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#export)**[ ](/spreadjs/api/classes/GC.Spread.Sheets.Workbook#export)method included with SpreadJS and the [file-saver npm package](https://www.npmjs.com/package/file-saver "https://www.npmjs.com/package/file-saver"){:target="_blank"}, Angular app developers can effortlessly export a spreadsheet state as an Excel file. First, install the file-saver npm package and save its type definitions.

```auto
npm install file-saver
npm i --save-dev @types/file-saver
```

Import the file-saver package to the **app.ts** file.

```auto
import { Component } from '@angular/core';
import { SpreadSheetsModule } from "@mescius/spread-sheets-angular";
import * as GC from "@mescius/spread-sheets";
import '@mescius/spread-sheets-io';
import '@mescius/spread-sheets-charts';
import { saveAs } from 'file-saver';
...
```

Next, update the `save()` function by first specifying the exported XLSX file name; we used “Excel\_Export.xlsx”, then invoke the SpreadJS export method, which exports the current spreadsheet state into a Blob. Within the export method, invoke the file-saver's `saveAs` method to save the exported spreadsheet Blob as an actual Excel file on the client side.

```auto
  // Save the instance as an Excel File
  save() {
    let fileName = 'Excel_Export.xlsx'
    if(this.spread){
      this.spread.export(function (blob:any) {
        // save blob to a file
        saveAs(blob, fileName);
      }, function (e:any) {
          console.log(e);
      }, {
          fileType: GC.Spread.Sheets.FileType.excel
      });
    }
  }
```

With these steps, you've successfully added Excel export functionality to the Angular spreadsheet application.
![Exporting XLSX files from an Angular Application](https://cdn.mescius.io/document-site-files/images/7719ad0a-f083-46d7-aff6-f63e2e187c15/excel-export-angular.7541c7.gif)

***

### Include Extra Features

If you want to import and export Excel files with Shapes and PivotTables, make sure to include those optional add-on modules for SpreadJS ([@mescius/spread-sheets-shapes](https://www.npmjs.com/package/@mescius/spread-sheets-shapes "https://www.npmjs.com/package/@mescius/spread-sheets-shapes"){:target="_blank"} and [@mescius/spread-sheets-pivot-addon](https://www.npmjs.com/package/@mescius/spread-sheets-pivot-addon "https://www.npmjs.com/package/@mescius/spread-sheets-pivot-addon"){:target="_blank"}).

***

### Import and Export Excel FAQs

**Do I need to have Excel installed for this import or export in Angular to work?**
No! SpreadJS is a stand-alone Angular component that can import and export Excel files without depending on Excel at all.
**Can my end users changes be included in the export?**
Yes! SpreadJS allows users to modify spreadsheets in an Excel-like experience. Those changes will be included when the spreadsheet is exported.
**What types of files can be imported or exported?**
SpreadJS supports import and export of .xlsx, .xlsm, .xltm file types. It can even import .csv files and has a custom SpreadJS (.sjs)file format for optimized performance and app development.
**Do you support Excel files with macros?**
The macros will not run, but Excel files with macros can be imported and exported without losing the macros. The macros simply will be ignored when the spreadsheet runs in SpreadJS. Note: most macro use cases can be replicated in custom JavaScript code using SpreadJS

***

### Next Steps

* [Download Local Tutorial Angular Sample App](https://drive.mescius.io/download?file=ExternalShare/SpreadJS/Samples/spreadjs-angular-io.zip "https://drive.mescius.io/download?file=ExternalShare/SpreadJS/Samples/spreadjs-angular-io.zip")
* [Check Out the Online Interactive Angular I/O Demo](https://developer.mescius.com/spreadjs/demos/features/spreadjs-file-format/overview/angular "https://developer.mescius.com/spreadjs/demos/features/spreadjs-file-format/overview/angular")